{
  pkgs,
  lib,
  ...
}: let
  common = pkgs.callPackage ./common.nix {};
in
  pkgs.writeShellScriptBin "run-extended-tests" ''

    ${common}

    echo_header "Running tests"
    echo_step "Downloading docker images"

    download_test_images
    setup_go_env

    echo_section "Running tests"
    if ! ${pkgs.go}/bin/go test -tags "runOnTask" -cover ./...
    then
      echo_fail "Failed to run tests"
      exit 1
    fi   

    echo_section "Running tests"
    if ! ${pkgs.go}/bin/go test -tags "runOnTask,bench" -bench ./...
    then
      echo_fail "Failed to run benchmarks"
      exit 1
    fi   

    echo_section "Running tests"
    if ! ${pkgs.go}/bin/go test -tags "runOnTask,race" -race ./...  
    then
      echo_fail "Failed to run race tests"
      exit 1
    fi   


  ''
