package jobqueue

import (
	"gotest.tools/v3/assert"
	"testing"
	"time"
)

func TestStructure(t *testing.T) {

	now := time.Now()
	oneHourBefore := now.Add(-1 * time.Hour)
	onHourAfter := now.Add(1 * time.Hour)

	ts := TimeScheduler{
		Time: oneHourBefore,
	}

	err := ts.Schedule(nil, nil)
	assert.ErrorIs(t, err, ErrParameterIsNil)

	job := &MockGenericJob{}
	err = ts.Schedule(job, nil)
	assert.ErrorIs(t, err, ErrScheduleTimeIsInThePast)

	ts.Time = onHourAfter
	err = ts.Schedule(job, nil)
	assert.ErrorIs(t, err, ErrJobIDEmpty)

	job.ID = "job-id"
	err = ts.Schedule(job, nil)
	assert.NilError(t, err)
	time.Sleep(2 * time.Second)
	err = ts.Cancel("job-id")
	assert.NilError(t, err)

	//time.Sleep(200 * time.Second)

}
